﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.3
@EndOfDesignText@

Sub Process_Globals
	Dim Connections As Map
	' when nothing is broadcasted, remove dead connections every 5 seconds
	Dim RemoveTimer As Timer
End Sub

public Sub Initialize()
	Connections = Main.srvr.CreateThreadSafeMap
	RemoveTimer.Initialize("RemoveTimer", 5000)
	RemoveTimer.Enabled = True
End Sub

public Sub AddTarget(path As String, resp As ServletResponse )
	path = path & "|" & GetGUID
	
	Log("Connecting: " & path)
	
	resp.ContentType = "text/event-stream"
	resp.SetHeader("Cache-Control","no-cache")
	resp.setHeader("Connection", "keep-alive")
	resp.CharacterEncoding = "UTF-8"
	
	resp.Status = 200
	
	Connections.Put(path, resp.OutputStream)
		
	SendMessage(resp.OutputStream, "open", "", 0, "")		
End Sub

public Sub Broadcast(Path As String, EventName As String, Message As String, Retry As Long)
	For Each key As String In Connections.Keys
		If key.StartsWith(Path & "|") Then
			Dim spl() As String = Regex.Split("|", key)
			Dim GUID As String = spl(1)
			Try
				Dim out As OutputStream = Connections.Get(key)
				SendMessage(out, EventName, Message, Retry, GUID)
			Catch
				Log("Removing: " & key)
				Connections.Remove(key)
			End Try
		End If
	Next	
End Sub

Sub RemoveTimer_Tick
	Dim ToRemoves As List
	ToRemoves.Initialize
	For Each key As String In Connections.Keys
		Try
			Dim out As OutputStream = Connections.Get(key)
			SendMessage(out, "Test", "", 0, "")
		Catch
			Log("Removing: " & key)
			Connections.Remove(key)
		End Try		
	Next	
End Sub

Private Sub SendMessage(out As OutputStream, eventName As String, message As String, retry As Int, id As String)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("event: " & eventName).Append(CRLF)
	If message <> "" Then
		sb.Append("data: " & message).Append(CRLF)
	End If	
	If retry > 0 Then
		sb.Append("retry: " & retry).Append(CRLF)
	End If
	If id <> "" Then
		sb.Append("id: " & retry).Append(CRLF)
	End If
	sb.Append(CRLF)
		
	Dim Bytes() As Byte = sb.ToString.GetBytes("UTF-8")
	out.WriteBytes(Bytes,0,Bytes.Length)
	out.Flush
End Sub

private Sub GetGUID() As String
	Dim jo As JavaObject
	Return jo.InitializeStatic("java.util.UUID").RunMethod("randomUUID", Null)
End Sub

